import java.util.Scanner;

public class LCS {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int m = in.nextInt(); //esimese jada pikkus
        int[] jada1 = new int[m];
        for (int i = 0; i < m; i++) {
            jada1[i] = in.nextInt(); //esimese jada elemendid
        }
        int n = in.nextInt(); //teise jada pikkus
        int[] jada2 = new int[n];
        for (int i = 0; i < n; i++) {
            jada2[i] = in.nextInt(); //teise jada elemendid
        }

        System.out.println(leiaYhised(jada1, jada2, m, n));
    }
    static int leiaYhised(int[] jada1, int[] jada2, int p1, int p2)
    {
        int[][] yhised = new int[p1 + 1][p2 + 1];
        for (int i = 0; i <= p1; i++) {
            yhised[i][0] = 0;
        }
        for (int j = 0; j <= p2; j++) {
            yhised[0][j] = 0;
        }
        for (int i = 1; i <= p1; i++) {
            for (int j = 1; j <= p2; j++) {
                if (jada1[i - 1] == jada2[j - 1]) {
                    yhised[i][j] = yhised[i - 1][j - 1] + 1;
                }
                else {
                    yhised[i][j] = Math.max((yhised[i - 1][j]), (yhised[i][j - 1]));
                }
            }
        }
        return yhised[p1][p2];
    }
}
