import java.util.Scanner;

public class Myndid2 {

    static int N;
    static int[] V;
    static int MaxInt = 2147483646;

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int S = in.nextInt(); //summa
        N = in.nextInt(); //mntide arv
        V = new int[N];
        for (int i = 0; i < N; i++) {
            V[i] = in.nextInt(); //vrtused
        }
        System.out.println(leiaKogus(S));
    }

    static int leiaKogus(int S)
    {
        int[] kogused = new int[S + 1];
        kogused[0] = 0;
        for (int i = 1; i <= S; i++) {
            //vrtusteks alguses lpmatused, kui selle koguseni ei juta, siis jb see
            //vrtus, sisuliselt thendab see, et sellel kohal asuvat summat ei saa antud
            //mntidest moodustada
            kogused[i] = MaxInt;
        }

        for (int i = 1; i <= S; i++) {
            for (int j = 0; j < N; j++) {
                if (V[j] <= i) { //jtab vahele mndid, mille vrtus on suurem kui summa
                    kogused[i] = Math.min(kogused[i - V[j]] + 1, kogused[i]);
                }
            }
        }
        return kogused[S];
    }
}
